<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input v-model="listQuery.username" clearable class="filter-item" style="width: 200px;" placeholder="请输入管理员名称" />
      <el-input v-model="listQuery.phone" clearable class="filter-item" style="width: 200px;" placeholder="请输入管理员账号" />
      <el-button v-permission="['GET /admin/admin/list']" class="filter-item" type="primary" icon="el-icon-search"
        @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/admin/create']" class="filter-item" type="primary" icon="el-icon-edit"
        @click="handleCreate">添加</el-button>
      <el-button :loading="downloadLoading" class="filter-item" type="primary" icon="el-icon-download"
        @click="handleDownload">导出</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column align="center" label="管理员ID" prop="id" sortable />

      <el-table-column align="center" label="管理员名称" prop="userName" />
      <el-table-column align="center" label="管理员账号" prop="userAccount" />

      <!-- <el-table-column align="center" label="管理员头像" prop="avatar">
        <template slot-scope="scope">
          <img v-if="scope.row.avatar" :src="scope.row.avatar" width="40">
        </template>
      </el-table-column> -->

      <el-table-column align="center" label="管理员角色" prop="roleIds" width="300px">
        <template slot-scope="scope">
          <el-tag v-for="roleId in scope.row.roleIds" :key="roleId" type="primary" style="margin-right: 20px;"> {{
            formatRole(roleId) }} </el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="是否为管家" prop="butlerType">
        <template slot-scope="scope">
          {{ scope.row.butlerType == 1 ? '是' : '否' }}
        </template>
      </el-table-column>
      <el-table-column align="center" label="负责城市" prop="citys" width="500px">
        <template slot-scope="scope">
          <el-tag v-for="city in scope.row.citys" :key="city.id" type="primary" style="margin-right: 20px;">
            {{ city.cityName }} </el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/admin/update']" type="primary" size="mini"
            @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/admin/delete']" type="danger" size="mini"
            @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit"
      @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px"
        style="width: 500px; margin-left:50px;">
        <el-form-item label="管理员名称" prop="userName">
          <el-input v-model="dataForm.userName" />
        </el-form-item>
        <el-form-item label="管理员账号" prop="userAccount">
          <el-input v-model="dataForm.userAccount" />
        </el-form-item>
        <el-form-item label="是否是管家" prop="isTop">
          <el-radio-group v-model="dataForm.butlerType" style="margin-top:10px">
            <el-radio :label="0">否</el-radio>
            <el-radio :label="1">是</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="管理员密码" prop="userPassword">
          <el-input v-model="dataForm.userPassword" type="password" auto-complete="off" />
        </el-form-item>
        <el-row>
          <el-col :span="20">
            <el-form-item label="负责渠道" prop="channelIds">
              <el-select v-model="dataForm.channelIds" style="width:100%" multiple placeholder="请选择负责渠道" @change="channelSelectCheck" clearable>
                <el-option v-for="item in channels" :key="item.id" :label="item.name" :value="item.id" />
              </el-select>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="4" style="padding-top:8px; padding-left:10px;">
            <el-checkbox v-model="channelSelectAll" @change="channelSelectCheck"> 全选</el-checkbox>
          </el-col> -->
        </el-row>
        <el-row>
          <el-col :span="20">
            <el-form-item label="管理员角色" prop="roleIds">
              <el-select v-model="dataForm.roleIds" style="width:100%;" multiple placeholder="请选择">
                <el-option v-for="item in roleOptions" :key="item.value" :label="item.label" :value="item.value" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="4" style="padding-top:8px; padding-left:10px;">
            <el-checkbox v-model="roleSelectAll" @change="roleSelectCheck"> 全选</el-checkbox>
          </el-col>

        </el-row>
        <el-row>
          <el-col :span="20">
            <el-form-item label="负责城市" prop="cityIds">
              <el-select v-model="cityIds" multiple placeholder="请选择负责城市" style="width:100%;" filterable clearable
                @change="citySelectCheck">
                <el-option v-for="item in citys" :key="item.id" :label="item.cityName" :value="item.id" />
              </el-select>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="4" style="padding-top:8px; padding-left:10px;">
            <el-checkbox v-model="citySelectAll" @change="citySelectCheck"> 全选</el-checkbox>
          </el-col> -->

        </el-row>
        <el-form-item label="选择负责门店" prop="shopIds">
          <el-select v-model="shopIds" clearable class="filter-item" placeholder="请选择门店" filterable multiple>
            <el-option v-for="item in shopList" :key="item.id" :label="item.shopName" :value="item.id" />
          </el-select>
        </el-form-item>

        <el-form-item label="管理员头像" prop="avatar">
          <el-upload :headers="headers" :action="uploadPath" :show-file-list="false" :on-success="uploadAvatar"
            class="avatar-uploader" accept=".jpg,.jpeg,.png,.gif">
            <img v-if="dataForm.avatar" :src="dataForm.avatar" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon" />
          </el-upload>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>


<script>

import { listAllCity } from '@/api/city'
import { allChannel } from "@/api/channel";
import { list, pass, reject, shopList } from '@/api/disjoin'
import { listAdmin, createAdmin, updateAdmin, deleteAdmin, readUserCitys } from '@/api/admin'
import { roleOptions } from '@/api/role'
import { uploadPath } from '@/api/storage'
import { getToken } from '@/utils/auth'
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination

export default {
  name: 'Admin',
  components: { Pagination },
  data() {
    return {
      channelSelectAll: false,
      roleSelectAll: false,
      citySelectAll: false,
      uploadPath,
      list: null,
      total: 0,
      citys: [],
      cityIds: [],
      shopIds: [],
      shopList: [],
      channels: [],
      roleOptions: null,
      listLoading: true,
      listQuery: {
        page: 1,
        limit: 20,
        username:'',
        phone:'',
        sort: 'create_time',
        order: 'desc'
      },
      dataForm: {
        id: undefined,
        userName: undefined,
        userPassword: undefined,
        userAccount: undefined,
        avatar: undefined,
        roleIds: [],
        butlerType: 1


      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑',
        create: '创建'
      },
      rules: {
        UserName: [{ required: true, message: '管理员名称不能为空', trigger: 'blur' }],
        UserPassword: [{ required: true, message: '密码不能为空', trigger: 'blur' }],
        userName: [{ required: true, message: '管理员名称不能为空', trigger: 'blur' }],
        userAccount: [{ required: true, message: '管理员帐号不能为空', trigger: 'blur' }]
      },
      downloadLoading: false
    }
  },
  computed: {
    headers() {
      return {
        'X-JZ-Admin-Token': getToken()
      }
    }
  },
  created() {
    this.getList();
    this.getShopList();

    roleOptions()
      .then(response => {
        this.roleOptions = response.data.data.list
      })

    listAllCity().then(res => {
      this.citys = res.data.data;
      this.citys.unshift({ id: 0, cityName: '全国' });
    })

    allChannel({ type: 1 }).then(res => {
      this.channels = res.data.data;
      this.channels.unshift({ id: 0, name: '全部渠道' });
    });
  },
  methods: {
    getShopList() {
      shopList().then(response => {
        this.shopList = response.data.data.list;
      })
        .catch(() => {

        })
    },
    formatRole(roleId) {
      for (let i = 0; i < this.roleOptions.length; i++) {
        if (roleId === this.roleOptions[i].value) {
          return this.roleOptions[i].label
        }
      }
      return ''
    },
    getList() {
      this.listLoading = true
      listAdmin(this.listQuery)
        .then(response => {
          this.list = response.data.data.list
          this.total = response.data.data.total
          this.listLoading = false
        })
        .catch(() => {
          this.list = []
          this.total = 0
          this.listLoading = false
        })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        userName: undefined,
        userAccount: undefined,
        userPassword: undefined,
        avatar: undefined,
        roleIds: [],
        butlerType: 0
      }
      this.cityIds = [];
      this.shopIds = [];
    },
    uploadAvatar: function (response) {
      this.dataForm.avatar = response.data.url
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    channelSelectCheck(value) {
      // if (value) {
      //   let list = [];
      //   this.channels.forEach(item => {
      //     list.push(item.id);
      //   });
      //   this.dataForm.channelIds = list;
      // } else {
      //   this.dataForm.channelIds = [];
      // }

      let list = value.filter(item => item == 0);  
      if (list.length > 0) this.dataForm.channelIds = [0]; 
    },
    citySelectCheck(value) { 
      let list = value.filter(item => item == 0);  
      if (list.length > 0) this.cityIds = [0]; 
    },
    roleSelectCheck(value) {
      if (value) {
        let list = [];
        this.roleOptions.forEach(item => {
          list.push(item.value);
        });
        this.dataForm.roleIds = list;
      } else {
        this.dataForm.roleIds = [];
      }
    },
    createData() {
      this.$refs['dataForm'].validate(valid => {
        if (valid) {
          createAdmin({ admin: this.dataForm, citys: this.cityIds, shopIds: this.shopIds })
            .then(response => {
              //this.list.unshift(response.data.data)
              this.getList()
              this.dialogFormVisible = false
              this.$notify.success({
                title: '成功',
                message: '添加管理员成功'
              })
            })
            .catch(response => {
              this.$notify.error({
                title: '失败',
                message: response.data.errmsg
              })
            })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);

      this.dataForm.butlerType = row.butlerType;
      this.shopIds = row.shops.map(item => { return item.id });
      readUserCitys(row.id).then(res => {
        this.cityIds = res.data.data
      })

      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      console.info(this.cityIds)
      this.$refs['dataForm'].validate(valid => {
        if (valid) {
          updateAdmin({ admin: this.dataForm, citys: this.cityIds, shopIds: this.shopIds })
            .then(() => {
              // for (const v of this.list) {
              //   if (v.id === this.dataForm.id) {
              //     const index = this.list.indexOf(v)
              //     this.list.splice(index, 1, this.dataForm)
              //     break
              //   }
              // }
              this.getList()
              this.dialogFormVisible = false
              this.$notify.success({
                title: '成功',
                message: '更新管理员成功'
              })
            })
            .catch(response => {
              this.$notify.error({
                title: '失败',
                message: response.data.errmsg
              })
            })
        }
      })
    },
    handleDelete(row) {
      deleteAdmin(row)
        .then(response => {
          this.$notify.success({
            title: '成功',
            message: '删除管理员成功'
          })
          const index = this.list.indexOf(row)
          this.list.splice(index, 1)
        })
        .catch(response => {
          this.$notify.error({
            title: '失败',
            message: response.data.errmsg
          })
        })
    },
    handleDownload() {
      this.downloadLoading = true
      import('@/vendor/Export2Excel').then(excel => {
        const tHeader = ['管理员ID', '管理员名称', '管理员头像']
        const filterVal = ['id', 'username', 'avatar']
        excel.export_json_to_excel2(
          tHeader,
          this.list,
          filterVal,
          '管理员信息'
        )
        this.downloadLoading = false
      })
    }
  }
}
</script>

<style>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.avatar-uploader .el-upload:hover {
  border-color: #20a0ff;
}

.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 120px;
  height: 120px;
  line-height: 120px;
  text-align: center;
}

.avatar {
  width: 145px;
  height: 145px;
  display: block;
}

.el-table th.gutter {
  display: table-cell !important;
}
</style>
